//********************************************************************** 
/*
@ddoqnl(24LC1025)\iڈj 
*/
//********************************************************************** 

#define		SW						GPIO.F3
#define		LED						GPIO.F2

#define		ON						1
#define		OFF						0

#define		ACK						1
#define		NO_ACK					0

#define		DATA_SIZE				0x20000
#define		DATA_SIZE_MAX			32
#define		DATA_SIZE1				1
#define		DATA_SIZE2				8
#define		DATA_SIZE3				16
#define		DATA_SIZE4				32

#define		WRITE_CYCLE_TIME		5

//********************************************************************** 

void	EEPROM_24LC1025_Page_Write(unsigned long addr, unsigned short *buf, unsigned short len)
{
	unsigned	short	cnt;
	//
	Soft_I2C_Start();
	if ((addr & 0x10000) == 0)
		Soft_I2C_Write(0xA0);
	else
		Soft_I2C_Write(0xA8);
	Soft_I2C_Write((addr >> 8) & 0xFF);
	Soft_I2C_Write(addr & 0xFF);
	for (cnt = 0; cnt < len; cnt++) {
		Soft_I2C_Write(buf[cnt]);
	}
	Soft_I2C_Stop();
}

//********************************************************************** 

void	EEPROM_24LC1025_Page_Read(unsigned long addr, unsigned short *buf, unsigned short len)
{
	unsigned	short	cnt;
	//
	Soft_I2C_Start();
	if ((addr & 0x10000) == 0)
		Soft_I2C_Write(0xA0);
	else
		Soft_I2C_Write(0xA8);
	Soft_I2C_Write((addr >> 8) & 0xFF);
	Soft_I2C_Write(addr & 0xFF);
	Soft_I2C_Start();
	if ((addr & 0x10000) == 0)
		Soft_I2C_Write(0xA1);
	else
		Soft_I2C_Write(0xA9);
	for (cnt = 0; cnt < (len - 1); cnt++) {
		buf[cnt] = Soft_I2C_Read(ACK);
	}
	buf[cnt] = Soft_I2C_Read(NO_ACK);
	Soft_I2C_Stop();
}

//********************************************************************** 

void	SwitchONcheck()
{
	while (Button(&GPIO, 3, 1, 0) == 0)
		;
	while (Button(&GPIO, 3, 1, 1) == 0)
		;
}

//********************************************************************** 

void main()
{
	static	unsigned	char	buf[DATA_SIZE_MAX], cnt;
	static	unsigned	long	addr;
	//
//	OSCCON = 0b01110000;
	CMCON0 = 0b00000111;
	ANSEL  = 0b00000000;
	TRISIO = 0b00001011;
	//
	for (cnt = 0; cnt < DATA_SIZE_MAX; cnt++) {
		LED = ON;
		Delay_ms(10);
		LED = OFF;
		Delay_ms(10);
		//
		buf[cnt] = cnt;
	}
	//
	Soft_I2C_Config(&GPIO, 1, 0);
	//
	while (1) {
		//1oCgPʂ̏݁ǂݏo 
		SwitchONcheck();
		addr = 0;
		while (1) {
			LED = ~LED;
			EEPROM_24LC1025_Page_Write(addr, buf, DATA_SIZE1);
			Delay_ms(WRITE_CYCLE_TIME);
			addr += DATA_SIZE1;
			if (addr >=DATA_SIZE)
				break;
		}
		SwitchONcheck();
		addr = 0;
		while (1) {
			LED = ~LED;
			EEPROM_24LC1025_Page_Read(addr, buf, DATA_SIZE1);
			Delay_ms(WRITE_CYCLE_TIME);
			for (cnt = 0; cnt < DATA_SIZE1; cnt++) {
				if (buf[cnt] != cnt) {
					while(1) {
						LED = ON;
					}
				}
			}
			addr += DATA_SIZE1;
			if (addr >=DATA_SIZE)
				break;
		}
		//8oCgPʂ̏݁ǂݏo 
		SwitchONcheck();
		addr = 0;
		while (1) {
			LED = ~LED;
			EEPROM_24LC1025_Page_Write(addr, buf, DATA_SIZE2);
			Delay_ms(WRITE_CYCLE_TIME);
			addr += DATA_SIZE2;
			if (addr >=DATA_SIZE)
				break;
		}
		SwitchONcheck();
		addr = 0;
		while (1) {
			LED = ~LED;
			EEPROM_24LC1025_Page_Read(addr, buf, DATA_SIZE2);
			Delay_ms(WRITE_CYCLE_TIME);
			for (cnt = 0; cnt < DATA_SIZE2; cnt++) {
				if (buf[cnt] != cnt) {
					while(1) {
						LED = ON;
					}
				}
			}
			addr += DATA_SIZE2;
			if (addr >=DATA_SIZE)
				break;
		}
		//16oCgPʂ̏݁ǂݏo 
		SwitchONcheck();
		addr = 0;
		while (1) {
			LED = ~LED;
			EEPROM_24LC1025_Page_Write(addr, buf, DATA_SIZE3);
			Delay_ms(WRITE_CYCLE_TIME);
			addr += DATA_SIZE3;
			if (addr >=DATA_SIZE)
				break;
		}
		SwitchONcheck();
		addr = 0;
		while (1) {
			LED = ~LED;
			EEPROM_24LC1025_Page_Read(addr, buf, DATA_SIZE3);
			Delay_ms(WRITE_CYCLE_TIME);
			for (cnt = 0; cnt < DATA_SIZE3; cnt++) {
				if (buf[cnt] != cnt) {
					while(1) {
						LED = ON;
					}
				}
			}
			addr += DATA_SIZE3;
			if (addr >=DATA_SIZE)
				break;
		}
		//32oCgPʂ̏݁ǂݏo 
		SwitchONcheck();
		addr = 0;
		while (1) {
			LED = ~LED;
			EEPROM_24LC1025_Page_Write(addr, buf, DATA_SIZE4);
			Delay_ms(WRITE_CYCLE_TIME);
			addr += DATA_SIZE4;
			if (addr >=DATA_SIZE)
				break;
		}
		SwitchONcheck();
		addr = 0;
		while (1) {
			LED = ~LED;
			EEPROM_24LC1025_Page_Read(addr, buf, DATA_SIZE4);
			Delay_ms(WRITE_CYCLE_TIME);
			for (cnt = 0; cnt < DATA_SIZE4; cnt++) {
				if (buf[cnt] != cnt) {
					while(1) {
						LED = ON;
					}
				}
			}
			addr += DATA_SIZE4;
			if (addr >=DATA_SIZE)
				break;
		}
	}
}

//********************************************************************** 
